      subroutine init_processes
      implicit none
      include "nlegborn.h"
      include "pwhg_flst.h"
      include "pwhg_st.h"
!      include "coupl.inc"
      integer i

#include "model_leptoq.h"
      integer j, k, flmax
      logical gluon_only_flag
      parameter (gluon_only_flag=.true.)

      integer finalid
!      parameter (finalid=773) ! lq4: Delta3p23
      parameter (finalid=774) ! lq5: Delta3m13
!      parameter (finalid=775) ! lq6: Delta3m43
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C    Set here the number of light flavours
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      st_nlight=5
      call init_couplings

! d u s c b t
! 1 2 3 4 5 6

!      call init_processes_born

      flmax = 0

! down-type
      do i = 1, 3
        do j = 1, 3
          if ((i.eq.j).or.
     &        (y3LL(i,1).ne.dcmplx(0d0).and.y3LL(j,1).ne.dcmplx(0d0)).or.
     &        (y3LL(i,2).ne.dcmplx(0d0).and.y3LL(j,2).ne.dcmplx(0d0)).or.
     &        (y3LL(i,3).ne.dcmplx(0d0).and.y3LL(j,3).ne.dcmplx(0d0))
     &       ) then
            flmax = flmax + 1
            flst_born(1, flmax) = 2*i - 1
            flst_born(2, flmax) = -2*j + 1
            flst_born(3, flmax) = finalid
            flst_born(4, flmax) = -finalid

            flmax = flmax + 1
            flst_born(1, flmax) = -2*j + 1
            flst_born(2, flmax) = 2*i - 1
            flst_born(3, flmax) = finalid
            flst_born(4, flmax) = -finalid
          endif
        enddo
      enddo

! up-type
      do i = 1, 2
        do j = 1, 2
          if ((i.eq.j).or.
     &        (y3LL(i,1).ne.dcmplx(0d0).and.y3LL(j,1).ne.dcmplx(0d0)).or.
     &        (y3LL(i,2).ne.dcmplx(0d0).and.y3LL(j,2).ne.dcmplx(0d0)).or.
     &        (y3LL(i,3).ne.dcmplx(0d0).and.y3LL(j,3).ne.dcmplx(0d0))
     &       ) then
            flmax = flmax + 1
            flst_born(1, flmax) = 2*i
            flst_born(2, flmax) = -2*j
            flst_born(3, flmax) = finalid
            flst_born(4, flmax) = -finalid
  
            flmax = flmax + 1
            flst_born(1, flmax) = -2*j
            flst_born(2, flmax) = 2*i
            flst_born(3, flmax) = finalid
            flst_born(4, flmax) = -finalid
          endif
        enddo
      enddo

      if (gluon_only_flag) then
        flmax = flmax + 1
        flst_born(1, flmax) = 0
        flst_born(2, flmax) = 0
        flst_born(3, flmax) = finalid
        flst_born(4, flmax) = -finalid
      endif

      flst_nborn = flmax

!      call init_processes_real

      flmax = 0

! down-type
      do i = 1, 3
        do j = 1, 3
          if ((i.eq.j).or.
     &        (y3LL(i,1).ne.dcmplx(0d0).and.y3LL(j,1).ne.dcmplx(0d0)).or.
     &        (y3LL(i,2).ne.dcmplx(0d0).and.y3LL(j,2).ne.dcmplx(0d0)).or.
     &        (y3LL(i,3).ne.dcmplx(0d0).and.y3LL(j,3).ne.dcmplx(0d0))
     &       ) then
            flmax = flmax + 1
            flst_real(1, flmax) = 2*i - 1
            flst_real(2, flmax) = -2*j + 1
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 0

            flmax = flmax + 1
            flst_real(1, flmax) = -2*j + 1
            flst_real(2, flmax) = 2*i - 1
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 0

            flmax = flmax + 1
            flst_real(1, flmax) = 0
            flst_real(2, flmax) = 2*i - 1
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 2*j - 1

            flmax = flmax + 1
            flst_real(1, flmax) = 0
            flst_real(2, flmax) = -2*j + 1
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = -2*i + 1

            flmax = flmax + 1
            flst_real(1, flmax) = -2*j + 1
            flst_real(2, flmax) = 0
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = -2*i + 1

            flmax = flmax + 1
            flst_real(1, flmax) = 2*i - 1
            flst_real(2, flmax) = 0
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 2*j - 1
          endif
        enddo
      enddo

! up-type
      do i = 1, 2
        do j = 1, 2
          if ((i.eq.j).or.
     &        (y3LL(i,1).ne.dcmplx(0d0).and.y3LL(j,1).ne.dcmplx(0d0)).or.
     &        (y3LL(i,2).ne.dcmplx(0d0).and.y3LL(j,2).ne.dcmplx(0d0)).or.
     &        (y3LL(i,3).ne.dcmplx(0d0).and.y3LL(j,3).ne.dcmplx(0d0))
     &       ) then
            flmax = flmax + 1
            flst_real(1, flmax) = 2*i
            flst_real(2, flmax) = -2*j
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 0

            flmax = flmax + 1
            flst_real(1, flmax) = -2*j
            flst_real(2, flmax) = 2*i
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 0

            flmax = flmax + 1
            flst_real(1, flmax) = 0
            flst_real(2, flmax) = 2*i
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 2*j

            flmax = flmax + 1
            flst_real(1, flmax) = 0
            flst_real(2, flmax) = -2*j
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = -2*i

            flmax = flmax + 1
            flst_real(1, flmax) = -2*j
            flst_real(2, flmax) = 0
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = -2*i

            flmax = flmax + 1
            flst_real(1, flmax) = 2*i
            flst_real(2, flmax) = 0
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 2*j
          endif
        enddo
      enddo

      if (gluon_only_flag) then
        flmax = flmax + 1
        flst_real(1, flmax) = 0
        flst_real(2, flmax) = 0
        flst_real(3, flmax) = finalid
        flst_real(4, flmax) = -finalid
        flst_real(5, flmax) = 0
      endif

      flst_nreal = flmax

!       do i = 1, flst_nborn
!         print *, "flst_born(1, ", i, ") = ", flst_born(1, i)
!         print *, "flst_born(2, ", i, ") = ", flst_born(2, i)
!         print *, "flst_born(3, ", i, ") = ", flst_born(3, i)
!         print *, "flst_born(4, ", i, ") = ", flst_born(4, i)
!         print *
!       enddo
! 
!       do i = 1, flst_nreal
!         print *, "flst_real(1, ", i, ") = ", flst_real(1, i)
!         print *, "flst_real(2, ", i, ") = ", flst_real(2, i)
!         print *, "flst_real(3, ", i, ") = ", flst_real(3, i)
!         print *, "flst_real(4, ", i, ") = ", flst_real(4, i)
!         print *, "flst_real(5, ", i, ") = ", flst_real(5, i)
!         print *
!       enddo
! 
!       print *, flst_nborn, flst_nreal
!       print *, y3LL(1,1).ne.dcmplx(0d0).and.y3LL(2,1).ne.dcmplx(0d0)
!       print *, y3LL(2,1), y3LL(2,1)
!       stop

c     if (tmass.eq.0d0) then
c        st_nlight=6
c     elseif(bmass.eq.0d0) then
c        st_nlight=5
c     elseif(cmass.eq.0d0) then
c        st_nlight=4
c     else
c        st_nlight=3
c     endif
      do i=3,nlegreal
         if (abs(flst_real(i,1)).le.st_nlight) then
            flst_lightpart=i
            exit
         endif
      enddo
 
      end
