

c Define common block containing all coupling constants and masses
c  which are used in the HELAS routines.
c
c  These include masses, widths and real/complex couplings.
c
c  This file can be built automatically from particles.dat and
c  interactions.dat
c
c====================================================================
c
c
c
c     QCD 
c
      double complex       gg(2)
      double precision     g
      common /COUPL_QCD/   g,gg   
c
c    kinematical masses
c
      double precision     hmass, wmass, zmass, amass,
     &                     tmass, bmass, lmass, cmass
      common /COUPL_MASS/  hmass, wmass, zmass, amass,
     &                     tmass, bmass, lmass, cmass
c
c   widths
c
      double precision     hwidth, wwidth, zwidth, 
     &                     twidth, lwidth, awidth
      common /COUPL_WIDTH/ hwidth, wwidth, zwidth, 
     &                     twidth, lwidth, awidth
c
c  couplings in the feynman rules
c
      double complex       gal(2), gad(2), gau(2), gwf(2),
     &                     gzn(2), gzl(2), gzd(2), gzu(2)
      double precision     gw, gwwa, gwwz
      common /COUPL_GAUGE/ gal   , gad   , gau   , gwf   ,
     &                     gzn   , gzl   , gzd   , gzu   ,
     &                     gw, gwwa, gwwz
c
      double complex       gwfc(2),  gwfs(2), gwfm(2)
      common /coupl_ckm/   gwfc,     gwfs   , gwfm	
c
      double complex       gwwh, gzzh, gwwhh, gzzhh, ghhh, ghhhh
      common /COUPL_SCAL/  gwwh, gzzh, gwwhh, gzzhh, ghhh, ghhhh
c
      double complex       ghtop(2), ghbot(2), ghtau(2), ghcha(2)
      common /COUPL_YUK/   ghtop   , ghbot   , ghtau   , ghcha


      double complex   GSLQ,G2SLQ,G1UL11(2),G1UL21(2),G1UL31(2),G1UL11C(2),G1UL21C(2),G1UL31C(2),G1UL12(2),G1U
     +L22(2),G1UL32(2),G1UL12C(2),G1UL22C(2),G1UL32C(2),G1UL13(2),G1UL23(2),G1UL33(2),G1UL13C(2),G1UL23C(2),G1UL33C(
     +2),G2UN11(2),G2UN21(2),G2UN31(2),G2UN11C(2),G2UN21C(2),G2UN31C(2),G2UN12(2),G2UN22(2),G2UN32(2),G2UN12C(2),G2U
     +N22C(2),G2UN32C(2),G2UN13(2),G2UN23(2),G2UN33(2),G2UN13C(2),G2UN23C(2),G2UN33C(2),G2DL11(2),G2DL21(2),G2DL31(2
     +),G2DL11C(2),G2DL21C(2),G2DL31C(2),G2DL12(2),G2DL22(2),G2DL32(2),G2DL12C(2),G2DL22C(2),G2DL32C(2),G2DL13(2),G2
     +DL23(2),G2DL33(2),G2DL13C(2),G2DL23C(2),G2DL33C(2),G3UL11(2),G3UL21(2),G3UL31(2),G3UL11C(2),G3UL21C(2),G3UL31C
     +(2),G3UL12(2),G3UL22(2),G3UL32(2),G3UL12C(2),G3UL22C(2),G3UL32C(2),G3UL13(2),G3UL23(2),G3UL33(2),G3UL13C(2),G3
     +UL23C(2),G3UL33C(2),G3DN11(2),G3DN21(2),G3DN31(2),G3DN11C(2),G3DN21C(2),G3DN31C(2),G3DN12(2),G3DN22(2),G3DN32(
     +2),G3DN12C(2),G3DN22C(2),G3DN32C(2),G3DN13(2),G3DN23(2),G3DN33(2),G3DN13C(2),G3DN23C(2),G3DN33C(2),G4UN11(2),G
     +4UN21(2),G4UN31(2),G4UN11C(2),G4UN21C(2),G4UN31C(2),G4UN12(2),G4UN22(2),G4UN32(2),G4UN12C(2),G4UN22C(2),G4UN32
     +C(2),G4UN13(2),G4UN23(2),G4UN33(2),G4UN13C(2),G4UN23C(2),G4UN33C(2),G5UL11(2),G5UL21(2),G5UL31(2),G5UL11C(2),G
     +5UL21C(2),G5UL31C(2),G5UL12(2),G5UL22(2),G5UL32(2),G5UL12C(2),G5UL22C(2),G5UL32C(2),G5UL13(2),G5UL23(2),G5UL33
     +(2),G5UL13C(2),G5UL23C(2),G5UL33C(2),G5DN11(2),G5DN21(2),G5DN31(2),G5DN11C(2),G5DN21C(2),G5DN31C(2),G5DN12(2),
     +G5DN22(2),G5DN32(2),G5DN12C(2),G5DN22C(2),G5DN32C(2),G5DN13(2),G5DN23(2),G5DN33(2),G5DN13C(2),G5DN23C(2),G5DN3
     +3C(2),G6DL11(2),G6DL21(2),G6DL31(2),G6DL11C(2),G6DL21C(2),G6DL31C(2),G6DL12(2),G6DL22(2),G6DL32(2),G6DL12C(2),
     +G6DL22C(2),G6DL32C(2),G6DL13(2),G6DL23(2),G6DL33(2),G6DL13C(2),G6DL23C(2),G6DL33C(2),G7DL11(2),G7DL21(2),G7DL3
     +1(2),G7DL11C(2),G7DL21C(2),G7DL31C(2),G7DL12(2),G7DL22(2),G7DL32(2),G7DL12C(2),G7DL22C(2),G7DL32C(2),G7DL13(2)
     +,G7DL23(2),G7DL33(2),G7DL13C(2),G7DL23C(2),G7DL33C(2),G8DN11(2),G8DN21(2),G8DN31(2),G8DN11C(2),G8DN21C(2),G8DN
     +31C(2),G8DN12(2),G8DN22(2),G8DN32(2),G8DN12C(2),G8DN22C(2),G8DN32C(2),G8DN13(2),G8DN23(2),G8DN33(2),G8DN13C(2)
     +,G8DN23C(2),G8DN33C(2),G9DL11(2),G9DL21(2),G9DL31(2),G9DL11C(2),G9DL21C(2),G9DL31C(2),G9DL12(2),G9DL22(2),G9DL
     +32(2),G9DL12C(2),G9DL22C(2),G9DL32C(2),G9DL13(2),G9DL23(2),G9DL33(2),G9DL13C(2),G9DL23C(2),G9DL33C(2)
      common /DC_COUPL/ GSLQ,G2SLQ,G1UL11,G1UL21,G1UL31,G1UL11C,G1UL21C,G1UL31C,G1UL12,G1UL22,G1UL32,G1UL12C,G
     +1UL22C,G1UL32C,G1UL13,G1UL23,G1UL33,G1UL13C,G1UL23C,G1UL33C,G2UN11,G2UN21,G2UN31,G2UN11C,G2UN21C,G2UN31C,G2UN1
     +2,G2UN22,G2UN32,G2UN12C,G2UN22C,G2UN32C,G2UN13,G2UN23,G2UN33,G2UN13C,G2UN23C,G2UN33C,G2DL11,G2DL21,G2DL31,G2DL
     +11C,G2DL21C,G2DL31C,G2DL12,G2DL22,G2DL32,G2DL12C,G2DL22C,G2DL32C,G2DL13,G2DL23,G2DL33,G2DL13C,G2DL23C,G2DL33C,
     +G3UL11,G3UL21,G3UL31,G3UL11C,G3UL21C,G3UL31C,G3UL12,G3UL22,G3UL32,G3UL12C,G3UL22C,G3UL32C,G3UL13,G3UL23,G3UL33
     +,G3UL13C,G3UL23C,G3UL33C,G3DN11,G3DN21,G3DN31,G3DN11C,G3DN21C,G3DN31C,G3DN12,G3DN22,G3DN32,G3DN12C,G3DN22C,G3D
     +N32C,G3DN13,G3DN23,G3DN33,G3DN13C,G3DN23C,G3DN33C,G4UN11,G4UN21,G4UN31,G4UN11C,G4UN21C,G4UN31C,G4UN12,G4UN22,G
     +4UN32,G4UN12C,G4UN22C,G4UN32C,G4UN13,G4UN23,G4UN33,G4UN13C,G4UN23C,G4UN33C,G5UL11,G5UL21,G5UL31,G5UL11C,G5UL21
     +C,G5UL31C,G5UL12,G5UL22,G5UL32,G5UL12C,G5UL22C,G5UL32C,G5UL13,G5UL23,G5UL33,G5UL13C,G5UL23C,G5UL33C,G5DN11,G5D
     +N21,G5DN31,G5DN11C,G5DN21C,G5DN31C,G5DN12,G5DN22,G5DN32,G5DN12C,G5DN22C,G5DN32C,G5DN13,G5DN23,G5DN33,G5DN13C,G
     +5DN23C,G5DN33C,G6DL11,G6DL21,G6DL31,G6DL11C,G6DL21C,G6DL31C,G6DL12,G6DL22,G6DL32,G6DL12C,G6DL22C,G6DL32C,G6DL1
     +3,G6DL23,G6DL33,G6DL13C,G6DL23C,G6DL33C,G7DL11,G7DL21,G7DL31,G7DL11C,G7DL21C,G7DL31C,G7DL12,G7DL22,G7DL32,G7DL
     +12C,G7DL22C,G7DL32C,G7DL13,G7DL23,G7DL33,G7DL13C,G7DL23C,G7DL33C,G8DN11,G8DN21,G8DN31,G8DN11C,G8DN21C,G8DN31C,
     +G8DN12,G8DN22,G8DN32,G8DN12C,G8DN22C,G8DN32C,G8DN13,G8DN23,G8DN33,G8DN13C,G8DN23C,G8DN33C,G9DL11,G9DL21,G9DL31
     +,G9DL11C,G9DL21C,G9DL31C,G9DL12,G9DL22,G9DL32,G9DL12C,G9DL22C,G9DL32C,G9DL13,G9DL23,G9DL33,G9DL13C,G9DL23C,G9D
     +L33C
      double precision LQ1MAS,LQ2MAS,LQ3MAS,LQ4MAS,LQ5MAS,LQ6MAS,LQ7MAS,LQ8MAS,LQ9MAS
      double precision LQ1WID,LQ2WID,LQ3WID,LQ4WID,LQ5WID,LQ6WID,LQ7WID,LQ8WID,LQ9WID
      common /USR_MASS/  LQ1MAS,LQ2MAS,LQ3MAS,LQ4MAS,LQ5MAS,LQ6MAS,LQ7MAS,LQ8MAS,LQ9MAS
      common /USR_DECAY/ LQ1WID,LQ2WID,LQ3WID,LQ4WID,LQ5WID,LQ6WID,LQ7WID,LQ8WID,LQ9WID
      double precision y2LR_11_r,y2LR_21_r,y2LR_31_r,y2LR_12_r,y2LR_22_r,y2LR_32_r,y2LR_13_r,y2LR_23_r,y2LR_33
     +_r,y2LR_11_i,y2LR_21_i,y2LR_31_i,y2LR_12_i,y2LR_22_i,y2LR_32_i,y2LR_13_i,y2LR_23_i,y2LR_33_i,y2RL_11_r,y2RL_21
     +_r,y2RL_31_r,y2RL_12_r,y2RL_22_r,y2RL_32_r,y2RL_13_r,y2RL_23_r,y2RL_33_r,y2RL_11_i,y2RL_21_i,y2RL_31_i,y2RL_12
     +_i,y2RL_22_i,y2RL_32_i,y2RL_13_i,y2RL_23_i,y2RL_33_i,y1LL_11_r,y1LL_21_r,y1LL_31_r,y1LL_12_r,y1LL_22_r,y1LL_32
     +_r,y1LL_13_r,y1LL_23_r,y1LL_33_r,y1LL_11_i,y1LL_21_i,y1LL_31_i,y1LL_12_i,y1LL_22_i,y1LL_32_i,y1LL_13_i,y1LL_23
     +_i,y1LL_33_i,y1RR_11_r,y1RR_21_r,y1RR_31_r,y1RR_12_r,y1RR_22_r,y1RR_32_r,y1RR_13_r,y1RR_23_r,y1RR_33_r,y1RR_11
     +_i,y1RR_21_i,y1RR_31_i,y1RR_12_i,y1RR_22_i,y1RR_32_i,y1RR_13_i,y1RR_23_i,y1RR_33_i,y3LL_11_r,y3LL_21_r,y3LL_31
     +_r,y3LL_12_r,y3LL_22_r,y3LL_32_r,y3LL_13_r,y3LL_23_r,y3LL_33_r,y3LL_11_i,y3LL_21_i,y3LL_31_i,y3LL_12_i,y3LL_22
     +_i,y3LL_32_i,y3LL_13_i,y3LL_23_i,y3LL_33_i,y2tildeRL_11_r,y2tildeRL_21_r,y2tildeRL_31_r,y2tildeRL_12_r,y2tilde
     +RL_22_r,y2tildeRL_32_r,y2tildeRL_13_r,y2tildeRL_23_r,y2tildeRL_33_r,y2tildeRL_11_i,y2tildeRL_21_i,y2tildeRL_31
     +_i,y2tildeRL_12_i,y2tildeRL_22_i,y2tildeRL_32_i,y2tildeRL_13_i,y2tildeRL_23_i,y2tildeRL_33_i,y1tildeRR_11_r,y1
     +tildeRR_21_r,y1tildeRR_31_r,y1tildeRR_12_r,y1tildeRR_22_r,y1tildeRR_32_r,y1tildeRR_13_r,y1tildeRR_23_r,y1tilde
     +RR_33_r,y1tildeRR_11_i,y1tildeRR_21_i,y1tildeRR_31_i,y1tildeRR_12_i,y1tildeRR_22_i,y1tildeRR_32_i,y1tildeRR_13
     +_i,y1tildeRR_23_i,y1tildeRR_33_i
