      subroutine init_processes
      implicit none
      include "nlegborn.h"
      include "pwhg_flst.h"
      include "pwhg_st.h"
!      include "coupl.inc"
      integer i

#include "model_leptoq.h"
      integer j, k, flmax
      logical gluon_only_flag
      parameter (gluon_only_flag=.true.)

      integer finalid
      parameter (finalid=770) ! lq1: Deltap53
!      parameter (finalid=771) ! lq2: Deltap23   !!! has different couplings, so the if conditions have to look different!
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C    Set here the number of light flavours
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      st_nlight=5
      call init_couplings

! d u s c b t
! 1 2 3 4 5 6

!      call init_processes_born

      flmax = 0

! down-type
      do i = 1, 3
        do j = 1, 3
!           if ((i.eq.j).or.
!      &        (y2RL(i,1).ne.dcmplx(0d0).and.y2RL(j,1).ne.dcmplx(0d0)).or.
!      &        (y2RL(i,2).ne.dcmplx(0d0).and.y2RL(j,2).ne.dcmplx(0d0)).or.
!      &        (y2RL(i,3).ne.dcmplx(0d0).and.y2RL(j,3).ne.dcmplx(0d0)).or.
!      &        (y2LR(i,1).ne.dcmplx(0d0).and.y2LR(j,1).ne.dcmplx(0d0)).or.
!      &        (y2LR(i,2).ne.dcmplx(0d0).and.y2LR(j,2).ne.dcmplx(0d0)).or.
!      &        (y2LR(i,3).ne.dcmplx(0d0).and.y2LR(j,3).ne.dcmplx(0d0))
!      &       ) then
          if (i.eq.j) then
            flmax = flmax + 1
            flst_born(1, flmax) = 2*i - 1
            flst_born(2, flmax) = -2*j + 1
            flst_born(3, flmax) = finalid
            flst_born(4, flmax) = -finalid

            flmax = flmax + 1
            flst_born(1, flmax) = -2*j + 1
            flst_born(2, flmax) = 2*i - 1
            flst_born(3, flmax) = finalid
            flst_born(4, flmax) = -finalid
          endif
        enddo
      enddo

! up-type
      do i = 1, 2
        do j = 1, 2
          if ((i.eq.j).or.
     &        (y2RL(i,1).ne.dcmplx(0d0).and.y2RL(j,1).ne.dcmplx(0d0)).or.
     &        (y2RL(i,2).ne.dcmplx(0d0).and.y2RL(j,2).ne.dcmplx(0d0)).or.
     &        (y2RL(i,3).ne.dcmplx(0d0).and.y2RL(j,3).ne.dcmplx(0d0)).or.
     &        (y2LR(i,1).ne.dcmplx(0d0).and.y2LR(j,1).ne.dcmplx(0d0)).or.
     &        (y2LR(i,2).ne.dcmplx(0d0).and.y2LR(j,2).ne.dcmplx(0d0)).or.
     &        (y2LR(i,3).ne.dcmplx(0d0).and.y2LR(j,3).ne.dcmplx(0d0))
     &       ) then
            flmax = flmax + 1
            flst_born(1, flmax) = 2*i
            flst_born(2, flmax) = -2*j
            flst_born(3, flmax) = finalid
            flst_born(4, flmax) = -finalid
  
            flmax = flmax + 1
            flst_born(1, flmax) = -2*j
            flst_born(2, flmax) = 2*i
            flst_born(3, flmax) = finalid
            flst_born(4, flmax) = -finalid
          endif
        enddo
      enddo

      if (gluon_only_flag) then
        flmax = flmax + 1
        flst_born(1, flmax) = 0
        flst_born(2, flmax) = 0
        flst_born(3, flmax) = finalid
        flst_born(4, flmax) = -finalid
      endif

      flst_nborn = flmax

!      call init_processes_real

      flmax = 0

! down-type
      do i = 1, 3
        do j = 1, 3
!           if ((i.eq.j).or.
!      &        (y2RL(i,1).ne.dcmplx(0d0).and.y2RL(j,1).ne.dcmplx(0d0)).or.
!      &        (y2RL(i,2).ne.dcmplx(0d0).and.y2RL(j,2).ne.dcmplx(0d0)).or.
!      &        (y2RL(i,3).ne.dcmplx(0d0).and.y2RL(j,3).ne.dcmplx(0d0)).or.
!      &        (y2LR(i,1).ne.dcmplx(0d0).and.y2LR(j,1).ne.dcmplx(0d0)).or.
!      &        (y2LR(i,2).ne.dcmplx(0d0).and.y2LR(j,2).ne.dcmplx(0d0)).or.
!      &        (y2LR(i,3).ne.dcmplx(0d0).and.y2LR(j,3).ne.dcmplx(0d0))
!      &       ) then
          if (i.eq.j) then
            flmax = flmax + 1
            flst_real(1, flmax) = 2*i - 1
            flst_real(2, flmax) = -2*j + 1
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 0

            flmax = flmax + 1
            flst_real(1, flmax) = -2*j + 1
            flst_real(2, flmax) = 2*i - 1
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 0

            flmax = flmax + 1
            flst_real(1, flmax) = 0
            flst_real(2, flmax) = 2*i - 1
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 2*j - 1

            flmax = flmax + 1
            flst_real(1, flmax) = 0
            flst_real(2, flmax) = -2*j + 1
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = -2*i + 1

            flmax = flmax + 1
            flst_real(1, flmax) = -2*j + 1
            flst_real(2, flmax) = 0
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = -2*i + 1

            flmax = flmax + 1
            flst_real(1, flmax) = 2*i - 1
            flst_real(2, flmax) = 0
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 2*j - 1
          endif
        enddo
      enddo

! up-type
      do i = 1, 2
        do j = 1, 2
          if ((i.eq.j).or.
     &        (y2RL(i,1).ne.dcmplx(0d0).and.y2RL(j,1).ne.dcmplx(0d0)).or.
     &        (y2RL(i,2).ne.dcmplx(0d0).and.y2RL(j,2).ne.dcmplx(0d0)).or.
     &        (y2RL(i,3).ne.dcmplx(0d0).and.y2RL(j,3).ne.dcmplx(0d0)).or.
     &        (y2LR(i,1).ne.dcmplx(0d0).and.y2LR(j,1).ne.dcmplx(0d0)).or.
     &        (y2LR(i,2).ne.dcmplx(0d0).and.y2LR(j,2).ne.dcmplx(0d0)).or.
     &        (y2LR(i,3).ne.dcmplx(0d0).and.y2LR(j,3).ne.dcmplx(0d0))
     &       ) then
            flmax = flmax + 1
            flst_real(1, flmax) = 2*i
            flst_real(2, flmax) = -2*j
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 0

            flmax = flmax + 1
            flst_real(1, flmax) = -2*j
            flst_real(2, flmax) = 2*i
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 0

            flmax = flmax + 1
            flst_real(1, flmax) = 0
            flst_real(2, flmax) = 2*i
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 2*j

            flmax = flmax + 1
            flst_real(1, flmax) = 0
            flst_real(2, flmax) = -2*j
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = -2*i

            flmax = flmax + 1
            flst_real(1, flmax) = -2*j
            flst_real(2, flmax) = 0
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = -2*i

            flmax = flmax + 1
            flst_real(1, flmax) = 2*i
            flst_real(2, flmax) = 0
            flst_real(3, flmax) = finalid
            flst_real(4, flmax) = -finalid
            flst_real(5, flmax) = 2*j
          endif
        enddo
      enddo

      if (gluon_only_flag) then
        flmax = flmax + 1
        flst_real(1, flmax) = 0
        flst_real(2, flmax) = 0
        flst_real(3, flmax) = finalid
        flst_real(4, flmax) = -finalid
        flst_real(5, flmax) = 0
      endif

      flst_nreal = flmax


c     if (tmass.eq.0d0) then
c        st_nlight=6
c     elseif(bmass.eq.0d0) then
c        st_nlight=5
c     elseif(cmass.eq.0d0) then
c        st_nlight=4
c     else
c        st_nlight=3
c     endif
      do i=3,nlegreal
         if (abs(flst_real(i,1)).le.st_nlight) then
            flst_lightpart=i
            exit
         endif
      enddo
 
      end
