      subroutine setvirtual(p,vflav,virtual)
c Virtual needs to be provided by the user and put here
      implicit none
      include 'nlegborn.h'
      include 'pwhg_st.h'
      include 'pwhg_math.h'

      real * 8 p(0:3,nlegborn)
      integer vflav(nlegborn), vflavs(nlegborn), v1, v2, v3, v4
      equivalence (v1,vflavs(1)), (v2,vflavs(2)), (v3,vflavs(3)), (v4,vflavs(4))
      real * 8 virtual, virtnoas, virtfull

#include "model_leptoq.h"
#include "formcalcuvir.h"

      real*8 min1, min2, mout1, mout2, psNorm, ex, ey, ez
      real*8 pc(0:3,nlegborn)

      real*8 result(4)
      integer*8 helicities
      integer flags

      integer mode
      real*8 norm

      pc = p
      vflavs = vflav

! CB: cross the momenta if initial particle 1 is anti
      if (v1.lt.0) then
        pc(:,2) = p(:,1)
        pc(:,1) = p(:,2)
        v1 = vflav(2)
        v2 = vflav(1)
      endif

      call set_ebe_couplings
      fc_mur2 = st_muren2


! CB

! helicities: 01010 01010 00100 00100 b = 338052 d, unpolarized
      helicities = 338052
! flags: 1 = "SETMASS", 2 = "RESET", 4 = "LOOP"
      flags = 2 + 4

      min1 = 0d0
      min2 = 0d0
      mout1 = MLQfinalstate1
      mout2 = MLQfinalstate2

      psNorm = sqrt(pc(1,1)**2 + pc(2,1)**2 + pc(3,1)**2)
      ex = pc(1,1)/psNorm
      ey = pc(2,1)/psNorm
      ez = pc(3,1)/psNorm
      call VecSet(1, min1, psNorm, ex, ey, ez)
      psNorm = sqrt(pc(1,2)**2 + pc(2,2)**2 + pc(3,2)**2)
      ex = pc(1,2)/psNorm
      ey = pc(2,2)/psNorm
      ez = pc(3,2)/psNorm
      call VecSet(2, min2, psNorm, ex, ey, ez)
      psNorm = sqrt(pc(1,3)**2 + pc(2,3)**2 + pc(3,3)**2)
      ex = pc(1,3)/psNorm
      ey = pc(2,3)/psNorm
      ez = pc(3,3)/psNorm
      call VecSet(3, mout1, psNorm, ex, ey, ez)
      psNorm = sqrt(pc(1,4)**2 + pc(2,4)**2 + pc(3,4)**2)
      ex = pc(1,4)/psNorm
      ey = pc(2,4)/psNorm
      ez = pc(3,4)/psNorm
      call VecSet(4, mout2, psNorm, ex, ey, ez)


! d u s c b t
! 1 2 3 4 5 6

      mode = -1

      if (v1.eq.0) then ! v1 and v2 are gluons
        mode = 2
        call clearcache_mult(1)
      else if (modulo(abs(v1),2).gt.0) then ! odd number, therefore d, s, b
        mode = 1
        iflav1 = (abs(v1) + 1)/2
        iflav2 = (abs(v2) + 1)/2
        if (iflav1.eq.iflav2) then
          call clearcache_mult(2)
        else
          call clearcache_mult(3)
        endif
      else ! (modulo(abs(v1),2).eq.0), even number, therefore u, c, t
        mode = 0
        iflav1 = abs(v1)/2
        iflav2 = abs(v2)/2
        if (iflav1.eq.iflav2) then
          call clearcache_mult(4)
        else
          call clearcache_mult(5)
        endif
      end if

      call setparam_collier(fc_uvdiv,fc_delta_uv,fc_mur2,fc_lambda_cll)
      if (mode == 0) then
         call LQtchan_0_RenConst
         call LQtchan_0_SquaredME(result, helicities, flags)
         virtfull = result(2)
         norm = 36d0
      else if (mode == 1) then
         call LQtchan_1_RenConst
         call LQtchan_1_SquaredME(result, helicities, flags)
         virtfull = result(2)
         norm = 36d0
      else if (mode == 2) then
         call LQtchan_2_RenConst
         call LQtchan_2_SquaredME(result, helicities, flags)
         virtfull = result(2)
         norm = 256d0
      end if

      virtual = virtfull/norm * (2d0*pi)/Alfas

      end
