      subroutine init_couplings
      implicit none
#include "model_leptoq.h"

      real * 8 powheginput
      external powheginput
c Avoid multiple calls to this subroutine. The parameter file is opened
c but never closed ...
      logical called
      data called/.false./
      save called
      if(called) then
         return
      else
         called=.true.
      endif

*********************************************************
***********         MADGRAPH                 ************
*********************************************************
c Parameters are read from the MadGraph param_card.dat,
c except the strong coupling constant, which is defined
c somewhere else
      call setpara("param_card.dat",.true.)

! initialise COLLIER
      call init_collier(4,5)

! initialise parameters for FormCalc and MG4
      call set_parameters

c *************
      MLQfinalstate1 = MLQR2
      MLQfinalstate2 = MLQR2
      numLQs = 2 ! 2*R2
c *************

      end

 
      subroutine set_ebe_couplings
      implicit none
      include 'pwhg_st.h'
      include 'pwhg_math.h'
#include "model_leptoq.h"
c QCD coupling constant
      Alfas = st_alpha
      Alfas2 = Alfas**2

      G=sqrt(Alfas*4d0*pi)
      GS=G
      GG(1)=-G
      GG(2)=-G

! CB
      GSLQ = dcmplx(-G)
      G2SLQ = dcmplx(G**2)
      return
      end


