      subroutine set_parameters
      implicit none
#include "model_leptoq.h"
#include "formcalcuvir.h"

      integer i, j

      MD = 0d0
      MD2 = 0d0
      MU = 0d0
      MU2 = 0d0
      MS = 0d0
      MS2 = 0d0
      MC = 0d0
      MC2 = 0d0
      MB = 0d0
      MB2 = 0d0
      MT = TMASS
      MT2 = MT**2

      ME = 0d0
      MM = 0d0
      ML = 0d0
      ME2 = ME**2
      MM2 = MM**2
      ML2 = ML**2

      do i = 1,4
        do j = 1,3
          Mf(i,j) = 0d0
        enddo
      enddo
      Mf(3,3) = MT
      do i = 1,4
        do j = 1,3
          Mf2(i,j) = Mf(i,j)**2
        enddo
      enddo

! CB: make sure that the width is set to zero, otherwise the NLO subtraction is screwed up
      LQ1WID = 0d0
      LQ2WID = 0d0
      LQ3WID = 0d0
      LQ4WID = 0d0
      LQ5WID = 0d0
      LQ6WID = 0d0
      LQ7WID = 0d0
      LQ8WID = 0d0
      LQ9WID = 0d0

      LQ2MAS = LQ1MAS ! both R2 states should have the same mass
      LQ5MAS = LQ4MAS ! all the three S3 states should have the same mass
      LQ6MAS = LQ4MAS ! all the three S3 states should have the same mass
      LQ8MAS = LQ7MAS ! both R2tilde states should have the same mass

      MLQR2 = LQ1MAS
      WLQR2 = LQ1WID
      MLQS1 = LQ3MAS
      WLQS1 = LQ3WID
      MLQS3 = LQ4MAS
      WLQS3 = LQ4WID
      MLQR2tilde = LQ7MAS
      WLQR2tilde = LQ7WID
      MLQS1tilde = LQ9MAS
      WLQS1tilde = LQ9WID

      MLQR22 = MLQR2**2
      MLQS12 = MLQS1**2
      MLQS32 = MLQS3**2
      MLQR2tilde2 = MLQR2tilde**2
      MLQS1tilde2 = MLQS1tilde**2

! CB: complex parameters
      MDC = dcmplx(MD)
      MD2C = dcmplx(MD2)
      MUC = dcmplx(MU)
      MU2C = dcmplx(MU2)
      MSC = dcmplx(MS)
      MS2C = dcmplx(MS2)
      MCC = dcmplx(MC)
      MC2C = dcmplx(MC2)
      MBC = dcmplx(MB)
      MB2C = dcmplx(MB2)
      MTC = dcmplx(MT)
      MT2C = dcmplx(MT2)

      MEC = dcmplx(ME)
      ME2C = dcmplx(ME2)
      MMC = dcmplx(MM)
      MM2C = dcmplx(MM2)
      MLC = dcmplx(ML)
      ML2C = dcmplx(ML2)

      do i = 1,4
        do j = 1,3
          MfC(i,j) = dcmplx(Mf(i,j))
          Mf2C(i,j) = dcmplx(Mf2(i,j))
        enddo
      enddo

      MLQR2C = dcmplx(MLQR2/dsqrt(2d0)*dsqrt(dsqrt(1d0 + (WLQR2/MLQR2)**2) + 1d0), -MLQR2/dsqrt(2d0)*dsqrt(dsqrt(1d0 + (WLQR2/MLQR2)**2) - 1d0))
      MLQS1C = dcmplx(MLQS1/dsqrt(2d0)*dsqrt(dsqrt(1d0 + (WLQS1/MLQS1)**2) + 1d0), -MLQS1/dsqrt(2d0)*dsqrt(dsqrt(1d0 + (WLQS1/MLQS1)**2) - 1d0))
      MLQS3C = dcmplx(MLQS3/dsqrt(2d0)*dsqrt(dsqrt(1d0 + (WLQS3/MLQS3)**2) + 1d0), -MLQS3/dsqrt(2d0)*dsqrt(dsqrt(1d0 + (WLQS3/MLQS3)**2) - 1d0))
      MLQR2tildeC = dcmplx(MLQR2tilde/dsqrt(2d0)*dsqrt(dsqrt(1d0 + (WLQR2tilde/MLQR2tilde)**2) + 1d0), -MLQR2tilde/dsqrt(2d0)*dsqrt(dsqrt(1d0 + (WLQR2tilde/MLQR2tilde)**2) - 1d0))
      MLQS1tildeC = dcmplx(MLQS1tilde/dsqrt(2d0)*dsqrt(dsqrt(1d0 + (WLQS1tilde/MLQS1tilde)**2) + 1d0), -MLQS1tilde/dsqrt(2d0)*dsqrt(dsqrt(1d0 + (WLQS1tilde/MLQS1tilde)**2) - 1d0))

      MLQR22C = MLQR2C**2
      MLQS12C = MLQS1C**2
      MLQS32C = MLQS3C**2
      MLQR2tilde2C = MLQR2tildeC**2
      MLQS1tilde2C = MLQS1tildeC**2

! couplings
      y2LR(1,1) = dcmplx(y2LR_11_r, y2LR_11_i)
      y2LR(2,1) = dcmplx(y2LR_21_r, y2LR_21_i)
      y2LR(3,1) = dcmplx(y2LR_31_r, y2LR_31_i)
      y2LR(1,2) = dcmplx(y2LR_12_r, y2LR_12_i)
      y2LR(2,2) = dcmplx(y2LR_22_r, y2LR_22_i)
      y2LR(3,2) = dcmplx(y2LR_32_r, y2LR_32_i)
      y2LR(1,3) = dcmplx(y2LR_13_r, y2LR_13_i)
      y2LR(2,3) = dcmplx(y2LR_23_r, y2LR_23_i)
      y2LR(3,3) = dcmplx(y2LR_33_r, y2LR_33_i)
      y2RL(1,1) = dcmplx(y2RL_11_r, y2RL_11_i)
      y2RL(2,1) = dcmplx(y2RL_21_r, y2RL_21_i)
      y2RL(3,1) = dcmplx(y2RL_31_r, y2RL_31_i)
      y2RL(1,2) = dcmplx(y2RL_12_r, y2RL_12_i)
      y2RL(2,2) = dcmplx(y2RL_22_r, y2RL_22_i)
      y2RL(3,2) = dcmplx(y2RL_32_r, y2RL_32_i)
      y2RL(1,3) = dcmplx(y2RL_13_r, y2RL_13_i)
      y2RL(2,3) = dcmplx(y2RL_23_r, y2RL_23_i)
      y2RL(3,3) = dcmplx(y2RL_33_r, y2RL_33_i)

      y1LL(1,1) = dcmplx(y1LL_11_r, y1LL_11_i)
      y1LL(2,1) = dcmplx(y1LL_21_r, y1LL_21_i)
      y1LL(3,1) = dcmplx(y1LL_31_r, y1LL_31_i)
      y1LL(1,2) = dcmplx(y1LL_12_r, y1LL_12_i)
      y1LL(2,2) = dcmplx(y1LL_22_r, y1LL_22_i)
      y1LL(3,2) = dcmplx(y1LL_32_r, y1LL_32_i)
      y1LL(1,3) = dcmplx(y1LL_13_r, y1LL_13_i)
      y1LL(2,3) = dcmplx(y1LL_23_r, y1LL_23_i)
      y1LL(3,3) = dcmplx(y1LL_33_r, y1LL_33_i)
      y1RR(1,1) = dcmplx(y1RR_11_r, y1RR_11_i)
      y1RR(2,1) = dcmplx(y1RR_21_r, y1RR_21_i)
      y1RR(3,1) = dcmplx(y1RR_31_r, y1RR_31_i)
      y1RR(1,2) = dcmplx(y1RR_12_r, y1RR_12_i)
      y1RR(2,2) = dcmplx(y1RR_22_r, y1RR_22_i)
      y1RR(3,2) = dcmplx(y1RR_32_r, y1RR_32_i)
      y1RR(1,3) = dcmplx(y1RR_13_r, y1RR_13_i)
      y1RR(2,3) = dcmplx(y1RR_23_r, y1RR_23_i)
      y1RR(3,3) = dcmplx(y1RR_33_r, y1RR_33_i)

      y3LL(1,1) = dcmplx(y3LL_11_r, y3LL_11_i)
      y3LL(2,1) = dcmplx(y3LL_21_r, y3LL_21_i)
      y3LL(3,1) = dcmplx(y3LL_31_r, y3LL_31_i)
      y3LL(1,2) = dcmplx(y3LL_12_r, y3LL_12_i)
      y3LL(2,2) = dcmplx(y3LL_22_r, y3LL_22_i)
      y3LL(3,2) = dcmplx(y3LL_32_r, y3LL_32_i)
      y3LL(1,3) = dcmplx(y3LL_13_r, y3LL_13_i)
      y3LL(2,3) = dcmplx(y3LL_23_r, y3LL_23_i)
      y3LL(3,3) = dcmplx(y3LL_33_r, y3LL_33_i)

      y2tildeRL(1,1) = dcmplx(y2tildeRL_11_r, y2tildeRL_11_i)
      y2tildeRL(2,1) = dcmplx(y2tildeRL_21_r, y2tildeRL_21_i)
      y2tildeRL(3,1) = dcmplx(y2tildeRL_31_r, y2tildeRL_31_i)
      y2tildeRL(1,2) = dcmplx(y2tildeRL_12_r, y2tildeRL_12_i)
      y2tildeRL(2,2) = dcmplx(y2tildeRL_22_r, y2tildeRL_22_i)
      y2tildeRL(3,2) = dcmplx(y2tildeRL_32_r, y2tildeRL_32_i)
      y2tildeRL(1,3) = dcmplx(y2tildeRL_13_r, y2tildeRL_13_i)
      y2tildeRL(2,3) = dcmplx(y2tildeRL_23_r, y2tildeRL_23_i)
      y2tildeRL(3,3) = dcmplx(y2tildeRL_33_r, y2tildeRL_33_i)

      y1tildeRR(1,1) = dcmplx(y1tildeRR_11_r, y1tildeRR_11_i)
      y1tildeRR(2,1) = dcmplx(y1tildeRR_21_r, y1tildeRR_21_i)
      y1tildeRR(3,1) = dcmplx(y1tildeRR_31_r, y1tildeRR_31_i)
      y1tildeRR(1,2) = dcmplx(y1tildeRR_12_r, y1tildeRR_12_i)
      y1tildeRR(2,2) = dcmplx(y1tildeRR_22_r, y1tildeRR_22_i)
      y1tildeRR(3,2) = dcmplx(y1tildeRR_32_r, y1tildeRR_32_i)
      y1tildeRR(1,3) = dcmplx(y1tildeRR_13_r, y1tildeRR_13_i)
      y1tildeRR(2,3) = dcmplx(y1tildeRR_23_r, y1tildeRR_23_i)
      y1tildeRR(3,3) = dcmplx(y1tildeRR_33_r, y1tildeRR_33_i)

      y2LR2(:,:) = y2LR(:,:)**2
      y2RL2(:,:) = y2RL(:,:)**2
      y1LL2(:,:) = y1LL(:,:)**2
      y1RR2(:,:) = y1RR(:,:)**2
      y3LL2(:,:) = y3LL(:,:)**2
      y2tildeRL2(:,:) = y2tildeRL(:,:)**2
      y1tildeRR2(:,:) = y1tildeRR(:,:)**2

      y2LRC = conjg(y2LR)
      y2LR2C = conjg(y2LR2)
      y2RLC = conjg(y2RL)
      y2RL2C = conjg(y2RL2)
      y1LLC = conjg(y1LL)
      y1LL2C = conjg(y1LL2)
      y1RRC = conjg(y1RR)
      y1RR2C = conjg(y1RR2)
      y3LLC = conjg(y3LL)
      y3LL2C = conjg(y3LL2)
      y2tildeRLC = conjg(y2tildeRL)
      y2tildeRL2C = conjg(y2tildeRL2)
      y1tildeRRC = conjg(y1tildeRR)
      y1tildeRR2C = conjg(y1tildeRR2)


      Divergence = 0d0
!      Divergence = 1d6

      fc_uvdiv = 0d0
      fc_delta_uv = 0d0
!      fc_delta_uv = 1d6
!      fc_mur2 = st_muren2
      fc_lambda_cll = 0d0

      end
