*#define CHECK

#if 0
* LQtchan_1_SquaredME.F
* assembly of squared matrix element
* generated by FormCalc 9.8 (22 Apr 2019) on 21-Jul-2021 22:05
#endif

#include "LQtchan_1_specs.h"
#include "LQtchan_1_vars.h"
#include "inline.h"
#include "contains.h"


************************************************************************

	subroutine LQtchan_1_SquaredMEHel(HelInd(vmax,res), flags)
	implicit none
	SIMD_ONLY(integer vmax)
	ResType res(HelDim(*))
	integer flags

#include "LQtchan_1_vars.h"

	HelType amp
	ResType ampsq
	integer iSUN, jSUN
#if DEBUG >= 3
	SIMD_ONLY(integer v)
#endif

* BEGIN ABBR_HEL
	call LQtchan_1_abbr0h
	TEST(flags, BIT_LOOP)
	call LQtchan_1_abbr1h
	ENDTEST(flags, BIT_LOOP)
* END ABBR_HEL

	ampsq = 0
* BEGIN FF_TREE
	LOOP(jSUN, 1,2,1)
	Ctree(HelAll(jSUN)) = 0
	ENDLOOP(jSUN)

	call LQtchan_1_borns
* END FF_TREE

* BEGIN M2_TREE
	LOOP(jSUN, 1,2,1)
	amp = 0
	LOOP(iSUN, 1,2,1)
	amp = amp + Ctree(HelAll(iSUN))*MatSUN(iSUN,jSUN)
	ENDLOOP(iSUN)
	ampsq = ampsq + Re(amp*Conjugate(Ctree(HelAll(jSUN))))
	ENDLOOP(jSUN)
* END M2_TREE
	res(HelAll(1)) = ampsq

	ampsq = 0
	TEST(flags, BIT_LOOP)
* BEGIN FF_LOOP
	LOOP(jSUN, 1,2,1)
	Cloop(HelAll(jSUN)) = 0
	ENDLOOP(jSUN)

	call LQtchan_1_selfs
	call LQtchan_1_verts
	call LQtchan_1_boxs

	LOOP(Gen5, 1,3,1)
	call LQtchan_1_selfs_Gen5
	ENDLOOP(Gen5)
* END FF_LOOP

* BEGIN M2_LOOP
	LOOP(jSUN, 1,2,1)
	amp = 0
	LOOP(iSUN, 1,2,1)
	amp = amp + Cloop(HelAll(iSUN))*MatSUN(iSUN,jSUN)
	ENDLOOP(iSUN)
	ampsq = ampsq + Re(amp*Conjugate(Ctree(HelAll(jSUN))))
	ENDLOOP(jSUN)
	ampsq = ampsq + ampsq
* END M2_LOOP
	ENDTEST(flags, BIT_LOOP)
	res(HelAll(2)) = ampsq

#if DEBUG >= 3
	print 1, HelLoop(Hel(HelInd(v,1:LEGS)), res(HelInd(v,1:2)), v,vmax)
1	format(' sqme(', LEGS I3, ') =', 2F25.12)
#endif
	end

************************************************************************

	subroutine LQtchan_1_SquaredME(result, helicities, flags)
	implicit none
	RealType result(*)
	integer*8 helicities
	integer flags

#include "LQtchan_1_vars.h"

* BEGIN VAR_DECL
	integer*8 hbits, hlast
	integer seq(2)
	save hlast, seq
	integer i, h, hmax
	parameter (hmax = 4)
	SIMD_ONLY(integer v)
	integer hsimd
	parameter (hsimd = SIMD_CEIL(hmax))
	ResType res(HelDim(2),hsimd)
	RealType rtree, rloop
	external LQtchan_1_SquaredMEHel
* END VAR_DECL

* BEGIN HSEL_DECL
	RealType norm
	RealType hseltest(0:hmax-1)
	ResType hseltest_v(HelDim(hsimd))
	equivalence (hseltest_v, hseltest)
	RealType hselmin
	integer hseli
	save hseltest, hselmin, hseli
* END HSEL_DECL

	data MatSUN /NaN(4)/

#include "inline.h"

* BEGIN SETMASS
	TEST(flags, BIT_SETMASS)
	result(1) = Mf(4,iflav1)
	result(2) = Mf(4,iflav2)
	result(3) = MLQS3C
	result(4) = MLQS3C
	return
	ENDTEST(flags, BIT_SETMASS)
* END SETMASS

* BEGIN INVARIANTS
	S = SInvariant(1,2)
	T = TInvariant(1,3)
	U = TInvariant(2,3)
	SC = dcmplx(S)
	TC = dcmplx(T)
	UC = dcmplx(U)
* END INVARIANTS

	CHK_INI(seq)

	TEST(flags, BIT_RESET)
	hlast = 0
	seq(1) = seq(1) + 1
	INI_S()
* BEGIN ABBR_S
	call LQtchan_1_abbr0s
	TEST(flags, BIT_LOOP)
	call LQtchan_1_abbr1s
	ENDTEST(flags, BIT_LOOP)
* END ABBR_S
	ENDTEST(flags, BIT_RESET)

	seq(2) = seq(2) + 1
	INI_A()
* BEGIN ABBR_ANGLE
	TEST(flags, BIT_LOOP)
	call LQtchan_1_abbr1a
	ENDTEST(flags, BIT_LOOP)
* END ABBR_ANGLE

* BEGIN HEL_LOOP
	helicities = iand(helicities, Generic(ARG_Phel,JOIN_HEL))

	SIMD_ONLY(v = 1)
	h = 0
	do i = 0, hmax - 1
* BEGIN HSEL_IF
	  if( hseltest(i) .lt. hselmin ) cycle
* END HSEL_IF

#define hval(s,m,a,b) a*mod(i/s,m)-b

	  Hel0(1) = hval(2,2,2,1)
	  Hel0(2) = hval(1,2,2,1)
	  Hel0(3) = 0
	  Hel0(4) = 0
	  hbits = Generic(ARG_Bhel,JOIN_HEL)
	  if( iand(hbits, helicities) .ne. hbits ) cycle
#if DEBUG >= 1
	  if( helicities .ne. hlast ) print 1, ' helicities: ', Hel0
#endif
	  SIMD_ONLY(call VecCopy(v, LEGS))
	  SIMD_ONLY(v = mod(v, SIMD) + 1)
	  SIMD_ONLY(if( v .eq. 1 ) then)
	  h = h + 1
	  call LQtchan_1_SquaredMEHel(HelInd(SIMD,res(HelAll(1),h)), flags)
	  SIMD_ONLY(endif)
	enddo

	SIMD_ONLY(if( v .ne. 1 ) then)
	SIMD_ONLY(h = h + 1)
	SIMD_ONLY(call LQtchan_1_SquaredMEHel(HelInd(v,res(HelAll(1),h)), flags))
	SIMD_ONLY(endif)
	DEINI()
	SIMD_ONLY(if( v .ne. 1 ) res(v:SIMD,:,h) = 0)
* END HEL_LOOP

* BEGIN RESULT
	rtree = 0
	rloop = 0
	do i = 1, h
	  rtree = rtree + HelSum(res(HelAll(1),i))
	  rloop = rloop + HelSum(res(HelAll(2),i))
	enddo
	result(1) = rtree
	TEST(flags, BIT_LOOP)
	result(2) = rloop
	ENDTEST(flags, BIT_LOOP)

#if DEBUG >= 2
	print *, PROCNAME, ' =', rtree, rloop
#endif
* END RESULT

* BEGIN HSEL_SET
	if( helicities .ne. hlast ) then
	  hseltest = 0
	  hselmin = 0
	  hseli = 0
	endif
	if( hseli .lt. hseln .and. rtree + rloop .ne. 0 ) then
	  norm = 1/(rtree + rloop)
	  do i = 1, hsimd
	    hseltest_v(HelAll(i)) = hseltest_v(HelAll(i)) +
     &        abs(norm*(res(HelAll(1),i) + res(HelAll(2),i)))
	  enddo
	  hseli = hseli + 1
	  if( hseli .eq. hseln ) then
	    hselmin = 0
	    do i = 0, hmax - 1
	      hselmin = max(hselmin, hseltest(i))
	    enddo
	    hselmin = hselmin*hseleps
	    do i = 0, hmax - 1
	      if( hseltest(i) .ge. hselmin ) cycle
	      Hel0(1) = hval(2,2,2,1)
	      Hel0(2) = hval(1,2,2,1)
	      Hel0(3) = 0
	      Hel0(4) = 0
	      print 1, ' neglecting ', Hel0
1	      format(A, LEGS I3)
	    enddo
	  endif
	endif
* END HSEL_SET

#ifdef CHECK
	print *, 'S =', S
	print *, 'T =', T
	print *, 'U =', U
	print *, 'tree =', rtree
	print *, 'loop =', rloop
	stop
#endif

	hlast = helicities

#include "contains.h"

	end

